Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections.map
Class TransformedMap

    java.lang.Object
      org.apache.commons.collections.map.AbstractMapDecorator
          org.apache.commons.collections.map.TransformedMap

All Implemented Interfaces:
  java.io.Serializable, java.util.Map

Direct Known Subclasses:
  TransformedSortedMap

    public class TransformedMap

extends AbstractMapDecorator
implements java.io.Serializable

Decorates another `Map` to transform objects that are added.

The Map put methods and Map.Entry setValue method are affected by this class. Thus objects must be removed or searched for using their transformed form. For example, if the transformation converts Strings to Integers, you must use the Integer form to remove objects.

Note that TransformedMap is not synchronized and is not thread-safe. If you wish to use this map from multiple threads concurrently, you must use appropriate synchronization. The simplest approach is to wrap this map using `Collections.synchronizedMap(Map)`. This class may throw exceptions when accessed by concurrent threads without synchronization.

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Stephen Colebourne
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface java.util.Map
`java.util.Map.Entry`

Field Summary
`protected Transformer` | `keyTransformer` The transformer to use for the key
`protected Transformer` | `valueTransformer` The transformer to use for the value

Fields inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`map`

Constructor Summary
`protected` | `TransformedMap(java.util.Map map, Transformer keyTransformer, Transformer valueTransformer)` Constructor that wraps (not copies).

Method Summary
`protected java.lang.Object` | `checkSetValue(java.lang.Object value)` Override to transform the value when using `setValue`.
`static java.util.Map` | `decorate(java.util.Map map, Transformer keyTransformer, Transformer valueTransformer)` Factory method to create a transforming map.
`static java.util.Map` | `decorateTransform(java.util.Map map, Transformer keyTransformer, Transformer valueTransformer)` Factory method to create a transforming map that will transform existing contents of the specified map.
`java.util.Set` | `entrySet()`
`protected boolean` | `isSetValueChecking()` Override to only return true when there is a value transformer.
`java.lang.Object` | `put(java.lang.Object key, java.lang.Object value)`
`void` | `putAll(java.util.Map mapToCopy)`
`protected java.lang.Object` | `transformKey(java.lang.Object object)` Transforms a key.
`protected java.util.Map` | `transformMap(java.util.Map map)` Transforms a map.
`protected java.lang.Object` | `transformValue(java.lang.Object object)` Transforms a value.

Methods inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`clear, containsKey, containsValue, equals, get, getMap, hashCode, isEmpty, keySet, remove, size, toString, values`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### keyTransformer

    protected final Transformer keyTransformer

  The transformer to use for the key

### valueTransformer

    protected final Transformer valueTransformer

  The transformer to use for the value

Constructor Detail

### TransformedMap

    protected TransformedMap(java.util.Map map,
                             Transformer keyTransformer,
                             Transformer valueTransformer)

  Constructor that wraps (not copies).

  If there are any elements already in the collection being decorated, they are NOT transformed.

  Parameters:
    `map` - the map to decorate, must not be null
    `keyTransformer` - the transformer to use for key conversion, null means no conversion
    `valueTransformer` - the transformer to use for value conversion, null means no conversion
  Throws:
    `java.lang.IllegalArgumentException` - if map is null

Method Detail

### decorate

    public static java.util.Map decorate(java.util.Map map,
                                         Transformer keyTransformer,
                                         Transformer valueTransformer)

  Factory method to create a transforming map.

  If there are any elements already in the map being decorated, they are NOT transformed. Constrast this with `decorateTransform(java.util.Map, org.apache.commons.collections.Transformer, org.apache.commons.collections.Transformer)`.

  Parameters:
    `map` - the map to decorate, must not be null
    `keyTransformer` - the transformer to use for key conversion, null means no transformation
    `valueTransformer` - the transformer to use for value conversion, null means no transformation
  Throws:
    `java.lang.IllegalArgumentException` - if map is null

### decorateTransform

    public static java.util.Map decorateTransform(java.util.Map map,
                                                  Transformer keyTransformer,
                                                  Transformer valueTransformer)

  Factory method to create a transforming map that will transform existing contents of the specified map.

  If there are any elements already in the map being decorated, they will be transformed by this method. Constrast this with `decorate(java.util.Map, org.apache.commons.collections.Transformer, org.apache.commons.collections.Transformer)`.

  Parameters:
    `map` - the map to decorate, must not be null
    `keyTransformer` - the transformer to use for key conversion, null means no transformation
    `valueTransformer` - the transformer to use for value conversion, null means no transformation
  Throws:
    `java.lang.IllegalArgumentException` - if map is null
  Since:
    Commons Collections 3.2

### transformKey

    protected java.lang.Object transformKey(java.lang.Object object)

  Transforms a key.

  The transformer itself may throw an exception if necessary.

  Parameters:
    `object` - the object to transform
  Throws:
    `the` - transformed object

### transformValue

    protected java.lang.Object transformValue(java.lang.Object object)

  Transforms a value.

  The transformer itself may throw an exception if necessary.

  Parameters:
    `object` - the object to transform
  Throws:
    `the` - transformed object

### transformMap

    protected java.util.Map transformMap(java.util.Map map)

  Transforms a map.

  The transformer itself may throw an exception if necessary.

  Parameters:
    `map` - the map to transform
  Throws:
    `the` - transformed object

### checkSetValue

    protected java.lang.Object checkSetValue(java.lang.Object value)

  Override to transform the value when using `setValue`.

  Parameters:
    `value` - the value to transform
  Returns:
    the transformed value
  Since:
    Commons Collections 3.1

### isSetValueChecking

    protected boolean isSetValueChecking()

  Override to only return true when there is a value transformer.

  Returns:
    true if a value transformer is in use
  Since:
    Commons Collections 3.1

### put

    public java.lang.Object put(java.lang.Object key,
                                java.lang.Object value)

  Specified by:
    `put` in interface `java.util.Map`
  Overrides:
    `put` in class `AbstractMapDecorator`

### putAll

    public void putAll(java.util.Map mapToCopy)

  Specified by:
    `putAll` in interface `java.util.Map`
  Overrides:
    `putAll` in class `AbstractMapDecorator`

### entrySet

    public java.util.Set entrySet()

  Specified by:
    `entrySet` in interface `java.util.Map`
  Overrides:
    `entrySet` in class `AbstractMapDecorator`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.